<template>
	<v-container class="superAdmin" :class="{ 'px-0': $vuetify.breakpoint.smAndDown }">
		<v-card>
			<v-tabs v-model="tab" grow>
				<v-tab v-for="item in tabItems" :key="item">{{ item }}</v-tab>
			</v-tabs>
			<v-divider />
			<v-tabs-items v-model="tab">
				<v-tab-item v-for="item in tabItems" :key="item">
					<fields-table
						v-if="item === 'Fields'"
						:is-loading="areResourcesLoading"
						:is-loaded="areResourcesLoaded"
						:has-error="hasResourcesError"
						:fields="fields"
					/>
					<users-table v-else-if="item === 'Users'" />
					<stratifications-table
						v-else-if="item === 'Stratifications'"
						:is-loading="areResourcesLoading"
						:is-loaded="areResourcesLoaded"
						:has-error="hasResourcesError"
						:stratifications="stratifications"
					/>
					<groups-table
						v-else-if="item === 'Groups'"
						:is-loading="areGroupsLoading"
						:is-loaded="areGroupsLoaded"
						:has-error="hasGroupsError"
						:groups="groups"
					/>
					<stratification-jobs-table v-else-if="item === 'Stratification Jobs'" />
				</v-tab-item>
			</v-tabs-items>
		</v-card>
	</v-container>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api';
import { useGroups } from '@/store/modules/group';
import { useAllResources } from '@/store/modules/resources';
import GroupsTable from '@/views/super-admin/GroupsTable.vue';
import StratifyButton from '../stratify/StratifyButton.vue';
import FieldsTable from './FieldsTable.vue';
import StratificationJobsTable from './StratificationJobsTable.vue';
import StratificationsTable from './StratificationsTable.vue';
import UsersTable from './UsersTable.vue';

export default defineComponent({
	components: {
		UsersTable,
		FieldsTable,
		StratificationsTable,
		GroupsTable,
		StratificationJobsTable,
		StratifyButton,
	},
	setup(_, { root }) {
		const tabItems = ['Fields', 'Users', 'Stratifications', 'Groups', 'Stratification Jobs'];
		const tab = ref<string>(tabItems[0]);
		const {
			isLoaded: areResourcesLoaded,
			isLoading: areResourcesLoading,
			fields,
			stratifications,
			hasError: hasResourcesError,
		} = useAllResources(root.$store);

		const { isLoaded: areGroupsLoaded, isLoading: areGroupsLoading, hasError: hasGroupsError, groups } = useGroups(
			root.$store
		);

		return {
			areResourcesLoaded,
			areResourcesLoading,
			hasResourcesError,
			areGroupsLoaded,
			areGroupsLoading,
			hasGroupsError,
			tabItems,
			tab,
			fields,
			stratifications,
			groups,
		};
	},
});
</script>

<style lang="scss">
.superAdmin .tableCard .v-data-table table {
	th {
		padding: 4px 8px;

		&:first-child {
			padding-left: 16px;
		}
		&:last-child {
			padding-right: 16px;
		}
	}

	td {
		padding: 4px 8px;
		min-width: 100px;

		&:first-child {
			word-break: break-all;
			padding-left: 16px;
		}

		&:last-child {
			padding-right: 16px;
		}
	}

	thead.v-data-table-header-mobile tr > th,
	tr.v-data-table__mobile-table-row > td {
		width: auto;
		padding: 16px;
	}
}

@media (min-width: 768px) {
	.superAdmin {
		&.container {
			max-width: 90%;
		}
	}
}
</style>
